QwtPlotZoomer(3)

NAME
QwtPlotZoomer - QwtPlotZoomer provides stacked zooming for a plot widget.

SYNOPSIS

#include <qwt_plot_zoomer.h>

Inherits QwtPlotPicker.

  Public Slots
void moveBy (double x, double y)
virtual void moveTo (const QPointF &)
virtual void zoom (const QRectF &)
Zoom in.
virtual void zoom (int up)
Zoom in or out.

  Signals
void zoomed (const QRectF &rect)

  Public Member Functions
QwtPlotZoomer (QWidget *, bool doReplot=true)
Create a zoomer for a plot canvas.
QwtPlotZoomer (int xAxis, int yAxis, QWidget *, bool doReplot=true)
Create a zoomer for a plot canvas.
virtual void setZoomBase (bool doReplot=true)
virtual void setZoomBase (const QRectF &)
Set the initial size of the zoomer.
QRectF zoomBase () const
QRectF zoomRect () const
virtual void setAxis (int xAxis, int yAxis)
void setMaxStackDepth (int)
Limit the number of recursive zoom operations to depth.
int maxStackDepth () const
const QStack< QRectF > & zoomStack () const
void setZoomStack (const QStack< QRectF > &, int zoomRectIndex=-1)
Assign a zoom stack.
uint zoomRectIndex () const

  Protected Member Functions
virtual void rescale ()
virtual QSizeF minZoomSize () const
Limit zooming by a minimum rectangle.
virtual void widgetMouseReleaseEvent (QMouseEvent *)
virtual void widgetKeyPressEvent (QKeyEvent *)
virtual void begin ()
virtual bool end (bool ok=true)
virtual bool accept (QPolygon &) const
Check and correct a selected rectangle.

  Additional Inherited Members

Detailed Description

QwtPlotZoomer provides stacked zooming for a plot widget. QwtPlotZoomer selects rectangles from user inputs ( mouse or keyboard ) translates them into plot coordinates and adjusts the axes to them. The selection is supported by a rubber band and optionally by displaying the coordinates of the current mouse position.

Zooming can be repeated as often as possible, limited only by maxStackDepth() or minZoomSize(). Each rectangle is pushed on a stack.

The default setting how to select rectangles is a QwtPickerDragRectMachine with the following bindings:

•   QwtEventPattern::MouseSelect1
     The first point of the zoom rectangle is selected by a mouse press, the second point from the position, where the mouse is released.

•   QwtEventPattern::KeySelect1
     The first key press selects the first, the second key press selects the second point.

•   QwtEventPattern::KeyAbort
     Discard the selection in the state, where the first point is selected.

To traverse the zoom stack the following bindings are used:

•   QwtEventPattern::MouseSelect3, QwtEventPattern::KeyUndo
     Zoom out one position on the zoom stack

•   QwtEventPattern::MouseSelect6, QwtEventPattern::KeyRedo
     Zoom in one position on the zoom stack

•   QwtEventPattern::MouseSelect2, QwtEventPattern::KeyHome
     Zoom to the zoom base

The setKeyPattern() and setMousePattern() functions can be used to configure the zoomer actions. The following example shows, how to configure the 'I' and 'O' keys for zooming in and out one position on the zoom stack. The 'Home' key is used to 'unzoom' the plot.

zoomer = new QwtPlotZoomer( plot );
zoomer->setKeyPattern( QwtEventPattern::KeyRedo, Qt::Key_I, Qt::ShiftModifier );
zoomer->setKeyPattern( QwtEventPattern::KeyUndo, Qt::Key_O, Qt::ShiftModifier );
zoomer->setKeyPattern( QwtEventPattern::KeyHome, Qt::Key_Home );

QwtPlotZoomer is tailored for plots with one x and y axis, but it is allowed to attach a second QwtPlotZoomer ( without rubber band and tracker ) for the other axes.

Note:
    The realtime example includes an derived zoomer class that adds scrollbars to the plot canvas.

See also:
    QwtPlotPanner, QwtPlotMagnifier

Constructor & Destructor Documentation

  QwtPlotZoomer::QwtPlotZoomer (QWidget * canvas, bool doReplot = true) [explicit]

Create a zoomer for a plot canvas. The zoomer is set to those x- and y-axis of the parent plot of the canvas that are enabled. If both or no x-axis are enabled, the picker is set to QwtPlot::xBottom. If both or no y-axis are enabled, it is set to QwtPlot::yLeft.

The zoomer is initialized with a QwtPickerDragRectMachine, the tracker mode is set to QwtPicker::ActiveOnly and the rubber band is set to QwtPicker::RectRubberBand

Parameters:
    canvas Plot canvas to observe, also the parent object
    doReplot Call QwtPlot::replot() for the attached plot before initializing the zoomer with its scales. This might be necessary, when the plot is in a state with pending scale changes.

See also:
    QwtPlot::autoReplot(), QwtPlot::replot(), setZoomBase()

  QwtPlotZoomer::QwtPlotZoomer (int xAxis, int yAxis, QWidget * canvas, bool doReplot = true) [explicit]

Create a zoomer for a plot canvas. The zoomer is initialized with a QwtPickerDragRectMachine, the tracker mode is set to QwtPicker::ActiveOnly and the rubber band is set to QwtPicker;;RectRubberBand

Parameters:
    xAxis X axis of the zoomer
    yAxis Y axis of the zoomer
    canvas Plot canvas to observe, also the parent object
    doReplot Call QwtPlot::replot() for the attached plot before initializing the zoomer with its scales. This might be necessary, when the plot is in a state with pending scale changes.

See also:
    QwtPlot::autoReplot(), QwtPlot::replot(), setZoomBase()

Member Function Documentation

  bool QwtPlotZoomer::accept (QPolygon & pa) const [protected], [virtual]

Check and correct a selected rectangle. Reject rectangles with a height or width < 2, otherwise expand the selected rectangle to a minimum size of 11x11 and accept it.

Returns:
    true If the rectangle is accepted, or has been changed to an accepted one.

Reimplemented from QwtPicker.

  void QwtPlotZoomer::begin () [protected], [virtual]
Rejects selections, when the stack depth is too deep, or the zoomed rectangle is minZoomSize().

See also:
    minZoomSize(), maxStackDepth()

Reimplemented from QwtPicker.

  bool QwtPlotZoomer::end (bool ok = true) [protected], [virtual]
Expand the selected rectangle to minZoomSize() and zoom in if accepted.

Parameters:
    ok If true, complete the selection and emit selected signals otherwise discard the selection.

See also:
    accept(), minZoomSize()

Returns:
    True if the selection has been accepted, false otherwise

Reimplemented from QwtPlotPicker.

  int QwtPlotZoomer::maxStackDepth () const

Returns:
    Maximal depth of the zoom stack.

See also:
    setMaxStackDepth()

  QSizeF QwtPlotZoomer::minZoomSize () const [protected], [virtual]

Limit zooming by a minimum rectangle.

Returns:
    zoomBase().width() / 10e4, zoomBase().height() / 10e4

  void QwtPlotZoomer::moveBy (double dx, double dy) [slot]
Move the current zoom rectangle.

Parameters:
    dx X offset
    dy Y offset

Note:
    The changed rectangle is limited by the zoom base

  void QwtPlotZoomer::moveTo (const QPointF & pos) [virtual], [slot]
Move the the current zoom rectangle.

Parameters:
    pos New position

See also:
    QRectF::moveTo()

Note:
    The changed rectangle is limited by the zoom base

  void QwtPlotZoomer::rescale () [protected], [virtual]
Adjust the observed plot to zoomRect()

Note:
    Initiates QwtPlot::replot()

  void QwtPlotZoomer::setAxis (int xAxis, int yAxis) [virtual]
Reinitialize the axes, and set the zoom base to their scales.

Parameters:
    xAxis X axis
    yAxis Y axis

Reimplemented from QwtPlotPicker.

  void QwtPlotZoomer::setMaxStackDepth (int depth)

Limit the number of recursive zoom operations to depth. A value of -1 set the depth to unlimited, 0 disables zooming. If the current zoom rectangle is below depth, the plot is unzoomed.

Parameters:
    depth Maximum for the stack depth

See also:
    maxStackDepth()

Note:
    depth doesn't include the zoom base, so zoomStack().count() might be maxStackDepth() + 1.

  void QwtPlotZoomer::setZoomBase (bool doReplot = true) [virtual]
Reinitialized the zoom stack with scaleRect() as base.

Parameters:
    doReplot Call QwtPlot::replot() for the attached plot before initializing the zoomer with its scales. This might be necessary, when the plot is in a state with pending scale changes.

See also:
    zoomBase(), scaleRect() QwtPlot::autoReplot(), QwtPlot::replot().

  void QwtPlotZoomer::setZoomBase (const QRectF & base) [virtual]

Set the initial size of the zoomer. base is united with the current scaleRect() and the zoom stack is reinitialized with it as zoom base. plot is zoomed to scaleRect().

Parameters:
    base Zoom base

See also:
    zoomBase(), scaleRect()

  void QwtPlotZoomer::setZoomStack (const QStack< QRectF > & zoomStack, int zoomRectIndex = -1)

Assign a zoom stack. In combination with other types of navigation it might be useful to modify to manipulate the complete zoom stack.

Parameters:
    zoomStack New zoom stack
    zoomRectIndex Index of the current position of zoom stack. In case of -1 the current position is at the top of the stack.

Note:
    The zoomed signal might be emitted.

See also:
    zoomStack(), zoomRectIndex()

  void QwtPlotZoomer::widgetKeyPressEvent (QKeyEvent * ke) [protected], [virtual]
Qt::Key_Plus zooms in, Qt::Key_Minus zooms out one position on the zoom stack, Qt::Key_Escape zooms out to the zoom base.

Changes the current position on the stack, but doesn't pop any rectangle.

Note:
    The keys codes can be changed, using QwtEventPattern::setKeyPattern: 3, 4, 5

Reimplemented from QwtPicker.

  void QwtPlotZoomer::widgetMouseReleaseEvent (QMouseEvent * me) [protected], [virtual]
Qt::MidButton zooms out one position on the zoom stack, Qt::RightButton to the zoom base.

Changes the current position on the stack, but doesn't pop any rectangle.

Note:
    The mouse events can be changed, using QwtEventPattern::setMousePattern: 2, 1

Reimplemented from QwtPicker.

  void QwtPlotZoomer::zoom (const QRectF & rect) [virtual], [slot]

Zoom in. Clears all rectangles above the current position of the zoom stack and pushes the normalized rectangle on it.

Note:
    If the maximal stack depth is reached, zoom is ignored.

    The zoomed signal is emitted.

  void QwtPlotZoomer::zoom (int offset) [virtual], [slot]

Zoom in or out. Activate a rectangle on the zoom stack with an offset relative to the current position. Negative values of offset will zoom out, positive zoom in. A value of 0 zooms out to the zoom base.

Parameters:
    offset Offset relative to the current position of the zoom stack.

Note:
    The zoomed signal is emitted.

See also:
    zoomRectIndex()

  QRectF QwtPlotZoomer::zoomBase () const

Returns:
    Initial rectangle of the zoomer

See also:
    setZoomBase(), zoomRect()

  void QwtPlotZoomer::zoomed (const QRectF & rect) [signal]
A signal emitting the zoomRect(), when the plot has been zoomed in or out.

Parameters:
    rect Current zoom rectangle.

  QRectF QwtPlotZoomer::zoomRect () const

Returns:
    Rectangle at the current position on the zoom stack.

See also:
    zoomRectIndex(), scaleRect().

  uint QwtPlotZoomer::zoomRectIndex () const

Returns:
    Index of current position of zoom stack.

  const QStack< QRectF > & QwtPlotZoomer::zoomStack () const

Returns:
    The zoom stack. zoomStack()[0] is the zoom base, zoomStack()[1] the first zoomed rectangle.

See also:
    setZoomStack(), zoomRectIndex()

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.